﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace BehaviorCollection.ShowPages
{
	public partial class AnimationPage : UserControl
	{
		public AnimationPage()
		{
			InitializeComponent();
		    AnimateVisibilityCmd = new AnimateVisibilityCommand{page = this};
		    ResetAnimateVisibilityCmd = new ResetAnimateVisibilityCommand{page = this};
			BouncingPaneCmd = new BouncingPaneCommand{page = this};

		    DataContext = this;
		}
		
		public ICommand AnimateVisibilityCmd {get; set;}
		public ICommand ResetAnimateVisibilityCmd {get; set;}
		
		public ICommand BouncingPaneCmd {get; set;}
		
	}

    public class AnimateVisibilityCommand : ICommand
    {
        public AnimationPage page { get; set; }

        #region ICommand Members

        public bool CanExecute(object parameter)
        {
            return !page.TA_visibility.HasBeenPlayed;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            page.T1P1.Visibility = Visibility.Collapsed;
        }

        #endregion
    }

    public class ResetAnimateVisibilityCommand : ICommand
    {
        public AnimationPage page { get; set; }

        #region ICommand Members

        public bool CanExecute(object parameter)
        {
            return page.TA_visibility.HasBeenPlayed;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            page.T1P1.Visibility = Visibility.Visible;
        }

        #endregion
    }

	public class BouncingPaneCommand : ICommand
    {
        public AnimationPage page { get; set; }

        #region ICommand Members

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            return;
        }

        #endregion
    }

}