﻿using System.Windows;
using System.Windows.Interactivity;

namespace Od.Behaviors.Appearance
{
    /// <summary>
    /// Toggle Visibility
    /// </summary>
public class ToggleVisibilityAction : TargetedTriggerAction<UIElement>
{
    /// <summary>
    /// Invokes the action.
    /// </summary>
    /// <param name="parameter">The parameter to the action. If the action does not require a parameter, the parameter may be set to a null reference.</param>
	protected override void Invoke(object parameter)
	{
		Target.Visibility = 
			Target.Visibility == Visibility.Visible ?
				Visibility.Collapsed : Visibility.Visible;
	}
}
}
