﻿#region Using(s)

using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;

#endregion

namespace Od.Behaviors.Commanding
{
    public class CommandOnEnterBehavior : Behavior<UIElement>
    {
        public static readonly DependencyProperty CommandProperty = DependencyProperty.Register("Command", typeof(ICommand), typeof(CommandOnEnterBehavior), null);

        public ICommand Command
        {
            get { return (ICommand)GetValue(CommandProperty); }
            set { SetValue(CommandProperty, value); }
        }

        protected override void OnAttached()
        {
            base.OnAttached();

            AssociatedObject.KeyDown += AssociatedObjectKeyDown;
        }

        private void AssociatedObjectKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key != Key.Enter) return;
            if (this.Command.CanExecute(null))
                this.Command.Execute(null);
            e.Handled = true;
        }
    }
}