﻿using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Interactivity;

namespace Od.Behaviors.Function
{
    public class OpenComboBoxBehavior : Behavior<ComboBox>
    {
        /// <summary>
        /// Called after the Behavior is attached to an AssociatedObject.
        /// </summary>
        /// <remarks>Override this to hook up functionality to the AssociatedObject.</remarks>
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.MouseEnter += AssociatedObject_MouseEnter;
        }

        /// <summary>
        /// Called after the Behavior is detached from an AssociatedObject.
        /// </summary>
        /// <remarks>Override this to hook up functionality to the AssociatedObject.</remarks>
        protected override void OnDetaching()
        {
            AssociatedObject.MouseEnter -= AssociatedObject_MouseEnter;
            base.OnDetaching();
        }

        /// <summary>
        /// When mouse is over ComboBox, control drop down will open
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void AssociatedObject_MouseEnter(object sender, MouseEventArgs e)
        {
            if (AssociatedObject != null) AssociatedObject.IsDropDownOpen = true;
        }
    }
}
