﻿using System.Windows;
using System.ComponentModel;
using System.Windows.Interactivity;

namespace Od.Behaviors.Function
{
    public class ShowMessageBoxAction : TargetedTriggerAction<FrameworkElement>
    {
        #region Property to Expose
        [Category("Message Box Properties")]
        public string MessageBoxText
        {
            get { return (string)GetValue(MessageBoxTextProperty); }
            set { SetValue(MessageBoxTextProperty, value); }
        }

        public static readonly DependencyProperty MessageBoxTextProperty =
            DependencyProperty.Register("MessageBoxText", typeof(string), typeof(ShowMessageBoxAction), new PropertyMetadata("Message"));

        #endregion

        protected override void Invoke(object o)
        {
            MessageBox.Show(MessageBoxText);
        }
    }
}