﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Media;

namespace Od.Behaviors.Utilities
{
    public static class VisualTree
    {
        public static IEnumerable<DependencyObject> GetChildren(this DependencyObject element)
        {
            int count = VisualTreeHelper.GetChildrenCount(element);
            for (int i = 0; i < count; i++)
            {
                yield return VisualTreeHelper.GetChild(element, i);
            }
        }

        public static DependencyObject FindNamedChild(this DependencyObject element, string elementName)
        {
            var elementQueue = new Queue<DependencyObject>();
            elementQueue.Enqueue(element);
            var tmpName = element.GetValue(FrameworkElement.NameProperty) as String;
            if (tmpName == elementName)
            {
                return element;
            }
            while (elementQueue.Count > 0)
            {
                var target = elementQueue.Dequeue();
                foreach (var child in target.GetChildren())
                {
                    var name = child.GetValue(FrameworkElement.NameProperty) as String;
                    if (name == elementName)
                    {
                        return child;
                    }
                    elementQueue.Enqueue(child);
                }

            }
            return null;
        }
    }
}
